@use './styles/form-file-upload.variations' as variations;
@use './styles/form-file-upload.variables' as *;
@use '../../../global/styles/styles-variables' as *;
@use '../../../global/styles/utilities' as *;

:host {
	@include digi-form-file-upload--variables;
	$base: '.digi-form-file-upload';

	.digi-form-file-upload {

		&--primary {
			@include variations.primary;
		}

		&--secondary {
			@include variations.secondary;	
		}
		
		&--tertiary {
			@include variations.tertiary;
		}

		&__icon {
			margin-bottom: var(--digi--margin--medium);
			opacity: 0.7;
			--digi--icon--height: #{rem(40)};
		}

		&__spinner {
			animation: animation__rotation .5s * 6 infinite linear;
  			transform-origin: center;
			--digi--icon--height: #{rem(16)};

			@media (prefers-reduced-motion) {
				animation: none;
			}

			@keyframes animation__rotation {

				from {
					transform: rotate(0deg);
				}
			
				to {
					transform: rotate(359deg);
				}
			}
		}

		&__input {
			display: none;
		}

		&__button {
			margin-top: auto;
			text-align: center;
			background: none;
			border: none;
			cursor: pointer;
			margin: 0;
			font-weight: var(--digi--typography--button--font-weight--desktop);
			font-size: var(--digi--typography--body--font-size--desktop);
			color: var(--digi--form-file-upload--button-text--color--default);
			display: flex;
			align-items: center;
			font-family: var(--digi--global--typography--font-family--default);

			&:hover {
				color: var(--digi--form-file-upload--button-text--color--hover);

				.digi-form-file-upload__button-icon {
					--digi--icon--color: var(--digi--form-file-upload--button-text--color--hover);
				}
				
			}
			
			&:focus  {
				border-color: var(--digi--global--color--function--info--base);
			}

			&-icon {
				width: 20px;
				height: 20px;
				margin-left: 5px;
			}

			&--mobile {

				@media (min-width: 500px) {
					display: none;
				}
			}
		}

		&__upload-area {
			border-color: var(--COLOR--BORDER--DEFAULT);
			border-radius: var(--BORDER-RADIUS--DEFAULT);
			border-width: var(--BORDER-WIDTH--DEFAULT);
			border-style: var(--BORDER-STYLE--DEFAULT);
			max-width: var(--WIDTH);
			display: flex;
			flex-direction: column;
			background-color: var(--COLOR--BACKGROUND--DEFAULT);
			align-items: center;
			padding: var(--PADDING);
			margin-bottom: var(--digi--gutter--medium);
			position: relative;
			cursor: pointer;

			&--hover {
				border-color: var(--COLOR--BORDER--HOVER);
			}
			
			&-overlay {
				position: absolute;
				width: 100%;
				height: 100%;
				background-color: var(--COLOR--BACKGROUND--HOVER);
				opacity: .1;
				top: 0;
				left: 0;
				z-index: 10;
			}

		} 

		&__text-area {
			display: flex;
			flex-direction: column;
			align-items: center;
			justify-content: center;
			text-align: center;
		}

		&__text {
			display: flex;
			flex-direction: column;
			align-items: center;
			text-align: center;

			&--tertiary {
				
				@media screen and (min-width: $digi--breakpoint--medium) {
					flex-direction: row;
					align-items: center;
				}
			}
		}
		
		&__files {
			border-radius: var(--BORDER-RADIUS--DEFAULT);
			max-width: 100%;
			background-color: var(--COLOR--BACKGROUND--DEFAULT);
			padding: var(--digi--gutter--largest-2) var(--digi--padding--large);
			margin-bottom: var(--digi--gutter--medium);
			margin-top: var(--digi--gutter--medium);
			padding-bottom: var(--digi--padding--smaller);

			ul {
				max-width: none;
				padding: 0;
				margin: 0;
			}

			h4 {
				margin: 0;
				padding: 0;
				font-weight: var(--digi--typography--body--font-weight--desktop);
			}
		}

		&__files-heading {
			font-family: var(--digi--form-file-upload--heading--font-family);
			font-size: var(--digi--form-file-upload--heading--font-size);
			font-weight: var(--digi--form-file-upload--heading--font-weight);
			color: var(--digi--color--text--primary);
			margin: 0;
			display: block;

			@media (min-width: $digi--breakpoint--large) {
				font-size: var(--digi--form-file-upload--heading--font-size--large);
			}
		}
		
		&__file {
			margin: var(--digi--margin--smaller) 0;
			padding: var(--digi--gutter--medium) 0;

			&-container {
				list-style-type: none;

				&:nth-child(n+2){
					border-top: var(--BORDER-WIDTH--DEFAULT) solid var(--COLOR--BORDER--DEFAULT);
				}
			}

			&-header {
				display: flex;
				align-items: center;

			}

			&-footer {
				padding-left: 30px;
			}

			&-name {
				overflow: hidden;
				margin-right: var(--digi--margin--smaller);
				text-overflow: ellipsis;
				max-width: 18.75rem;
				padding: var(--digi--padding--smaller);
				white-space: nowrap;
				height: max-content;
				margin: 0 auto 0 0;
				padding: 0 .5rem  0 .5rem;
				
				@media (max-width: 500px) {
					padding: 0 .5rem 0 0;
					max-width: 12.75rem;
				}
			}

			&-icon {
				display: flex;
				justify-content: center;
				align-items: center;
			}

			&-info {
				width: 100%;
			}

			span {
				height: max-content;
				margin-left: var(--digi--margin--smaller);
				
				@media (max-width: 500px) {
					margin-left: 0;
					margin-right: auto;
					
				}
			}

			&-button {
				margin-left: auto;
				font-weight: var(--digi--global--typography--font-weight--semibold);
			
			}

			&--error {
				display: flex;
				color: red;

				@media (max-width: 500px) {
					span {
						display: none;
					}
				}
			}

		}

		&__error {
			color: var(--digi--color--icons--danger);
		}
	}

	.visually-hidden {
		@include digi--a11y--sr-only;
  	}

	.hidden-mobile {
		@media (max-width: 500px) {
			display: none;
		}
	}

}
